darcs-2.8.4: a distributed, interactive, smart revision control system

Safe Haskell | None

Darcs.Patch.Prim.V3.Core

# Documentation

data Prim x y where

Constructors

BinaryHunk :: !UUID -> Hunk x y -> Prim x y |
TextHunk :: !UUID -> Hunk x y -> Prim x y |
Manifest :: !UUID -> Location -> Prim x y |
Demanifest :: !UUID -> Location -> Prim x y |
Move :: !UUID -> Location -> Location -> Prim x y |
Identity :: Prim x x |

Instances

Show2 Prim |
PatchListFormat Prim |
MyEq Prim |
Commute Prim |
Invert Prim |
PatchInspect Prim |
ReadPatch Prim |
Apply Prim |
RepairToFL Prim |
ShowPatch Prim |
ShowPatchBasic Prim |
Patchy Prim |
IsHunk Prim |
PrimApply Prim |
PrimRead Prim |
PrimShow Prim |
PrimDetails Prim |
PrimCanonize Prim |
PrimConstruct Prim |
PrimClassify Prim |
FromPrim Prim |
PrimPatchBase Prim |
PrimPatch Prim |
Show1 (Prim x) |
Eq (Prim x y) |
Show (Prim x y) |

data Hunk x y where

Constructors

Hunk :: !Int -> ByteString -> ByteString -> Hunk x y |

Instances

MyEq Hunk |

newtype UUID

Constructors

UUID ByteString |

Instances

Eq UUID |
Ord UUID |
Show UUID |

type Location = (UUID, ByteString)

data Object m

Constructors

Directory DirContent |
Blob (m ByteString) !Hash |

touches :: Prim x y -> [UUID]

hunkEdit :: Hunk x y -> ByteString -> ByteString